#include "includes.h"
#include "support.h"

unsigned long   GetPID()
{
#ifdef  __WIN32__
        return (unsigned long) GetCurrentProcessId();
#else
        return (unsigned long) getpid();
#endif
}

IDF::IDF(int id)
{
#ifdef  __WIN32__
        GlobalID = (unsigned short) GetCurrentProcessId();
#else
        GlobalID = (unsigned short) getpid();
#endif
        LocalID = (unsigned short) id;
}

unsigned long   IDF::GetID()
{
        unsigned long id;

        id = GlobalID;
        id <<= 16;
        id += LocalID;
        LocalID++;

        return id;
}

char *  ipname(unsigned char *ip)
{
        return inet_ntoa(((struct in_addr *) ip) [0]);
}

char *  FmtHW(unsigned char *s,int len)
{
        static char FmtString[128];
        int c = 0;
        while(c < len) {
                sprintf(&FmtString[c*3],"%02X:",s[c]);
                c++;
        };
        FmtString[c*3 - 1] = 0;
        return FmtString;
}

int     HWName::operator != (int) const
{
        return Name[0];
}

void    HWName::operator = (const char *s)
{
        if(s == 0) {
                Name[0] = 0;
                memset(Address,0,6);
                return;
        };

        int c,i,d,e;
        char conv[3];

        strcpy(Name,s);

        c = 0;
        d = 0;
        e = 0;
        while(1) {
                if(s[c] == ':' || s[c] == 0) {
                        if(d <= 2 &&
                           isxdigit(conv[0]) != 0 &&
                           isxdigit(conv[1]) != 0) {
                                conv[d] = 0;
                                sscanf(conv,"%02X",&i);
                                Address[e] = (unsigned char) i;
                                e++;
                        };

                        if(s[c] == 0) break;
                        d = 0;
                }
                else if(d < 2) {
                        conv[d] = s[c];
                        d++;
                }
                else d++;
                c++;
        };

        AddressLength = e;
}

HWName::HWName(const char *s)
{
        this[0] = s;
}

int     IPName::operator != (int) const
{
        return Name[0];
}

void    IPName::operator = (const char *s)
{
        if(s) {
                strcpy(Name,s);
                ((unsigned long *) Address) [0] = inet_addr(s);
        }
        else {
                Name[0] = 0;
                ((unsigned long *) Address) [0] = 0;
        };
}

IPName::IPName(const char *ip)
{
        this[0] = ip;
}

unsigned long   GetTicks()
{
        unsigned long t;

#ifdef  __WIN32__
        t = clock();
        t *= 1000;
        t /= CLOCKS_PER_SEC;
#else
        timeval tv;
        gettimeofday(&tv,0);
        t = tv.tv_sec * 1000;
        t += tv.tv_usec / 1000;
#endif
        return t;
}

unsigned long   GetSecs()
{
#ifdef  __WIN32__
        unsigned long t;
        t = clock();
        t /= CLOCKS_PER_SEC;
        return t;
#else
        timeval tv;
        gettimeofday(&tv,0);
        return tv.tv_sec;
#endif
}

